#region UICode
bool Amount1 = false; // [0,1] Invert 'Mask'
bool Amount2 = true; // [0,1] Blend Alpha?
double Amount3 = 0; // [-100,100] Transparency
bool Amount4 = false; // [0,1] Silhouette?
ColorBgra Amount5 = ColorBgra.FromBgr(0,0,0); // Color of Silhouette
#endregion

void Render(Surface dst, Surface src, Rectangle rect)
{
    ColorBgra CurrentPixel;
    for (int y = rect.Top; y < rect.Bottom; y++)
    {
        for (int x = rect.Left; x < rect.Right; x++)
        {
            CurrentPixel = src[x,y];

            byte tempC = (byte)(int)((CurrentPixel.R + CurrentPixel.G + CurrentPixel.B)/3);
            int luma = (int)((CurrentPixel.R * 0.3) + (CurrentPixel.G * 0.59) + (CurrentPixel.B * 0.11));
            float colA = (float)(byte)(CurrentPixel.A);
            if(Amount1 == false){
                if(Amount2 == true){
                    
                    CurrentPixel.A = (byte)((colA / 255) * luma);
                }
                else{
                    CurrentPixel.A = (byte)(luma);
                }
            }
            else if(Amount1 == true){
                if(Amount2 == true){
                    CurrentPixel.A = (byte)(((colA) / 255) * (255 - luma));
                }
                else{
                     CurrentPixel.A = (byte)(255 - luma);
                }
            }
            if(Amount4 == true){
                CurrentPixel.R = Amount5.R;
                CurrentPixel.G = Amount5.G;
                CurrentPixel.B = Amount5.B;
            }
            if(Amount3 < 0){
                CurrentPixel.A = (byte)(double) (CurrentPixel.A + (CurrentPixel.A * (Amount3 / 100.0)));
            }
            else if(Amount3 > 0){
                CurrentPixel.A = (byte)(double) (CurrentPixel.A + ((255-CurrentPixel.A) * (Amount3 / 100.0)));
            }
                
            
            dst[x,y] = CurrentPixel;
        }
    }
}
